SystemOrganization addCategory: #'GrandMa-Tests'!

TestCase subclass: #GMQueueTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GrandMa-Tests'!

!GMQueueTest methodsFor: 'tests' stamp: 'FrancoisStephany 4/12/2012 09:05'!
testConsumeTask
	| q |
	q := GMQueue new.
	q addTask:  (GMTask new command: 'first').
	q addTask: (GMTask new command: 'second').
	q consumeTask.
	self assert: q pendingTasks size equals: 1.! !

!GMQueueTest methodsFor: 'tests' stamp: 'FrancoisStephany 4/11/2012 23:40'!
testFIFO
	| q |
	q := GMQueue new.
	q addTask: 'first'.
	q addTask: 'second'.
	self assert: q consumeTask equals: 'first'.
	self assert: q consumeTask equals: 'second'.
	self assert: q consumeTask isNil.! !

!GMQueueTest methodsFor: 'tests' stamp: 'FrancoisStephany 4/13/2012 15:07'!
testSuccess
	| success q task |
	success := false.
	q := GMQueue new.
	task := GMTask new 
		command: 'first';
		callback: [ :output | success := true ].

	q addTask: task.
	q consumeTask.
	q success: (Dictionary new 
		at: #uuid put: task uuid;
		at: #message put: 'command output';
		yourself).
	self assert: q pendingTasks isEmpty.
	self assert: success.! !

TestCase subclass: #GMTaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GrandMa-Tests'!

!GMTaskTest methodsFor: 'test' stamp: 'FrancoisStephany 4/13/2012 15:12'!
testInitialize
	| a b |
	a := GMTask new.
	b := GMTask new.
	self deny: a uuid isNil.
	self deny: a uuid = b uuid.
	self deny: a callback isNil.! !
